//#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <bitset>
#define mp make_pair
#define pb push_back

#ifdef LOCAL
#define eprintf(...) fprintf(stderr,__VA_ARGS__)
#else
#define eprintf(...)
#endif

#define TIMESTAMP(x) eprintf("["#x"] Time : %.3lf s.\n", clock()*1.0/CLOCKS_PER_SEC)
#define TIMESTAMPf(x,...) eprintf("[" x "] Time : %.3lf s.\n", __VA_ARGS__, clock()*1.0/CLOCKS_PER_SEC)

#if ( ( _WIN32 || __WIN32__ ) && __cplusplus < 201103L)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

#define TASKNAME "turtles"

#ifdef LOCAL
static struct __timestamper {
    string what;
    __timestamper(const char* what) : what(what){};
    __timestamper(const string& what) : what(what){};
	~__timestamper(){
        TIMESTAMPf("%s", what.data());
	}
} __TIMESTAMPER("end");
#else 
struct __timestamper {};
#endif

typedef long long ll;
typedef long double ld;


int main(){
    assert(freopen(TASKNAME".in","r",stdin));
    assert(freopen(TASKNAME".out","w",stdout));

  	int w, h;
  	scanf("%d%d",&h,&w);

  	vector<int> minx(h, 1e9), miny(w, 1e9), maxx(h, -1), maxy(w, -1);

  	int n;
  	scanf("%d",&n);
  	bool reqs = false;
  	long long need = 0;
  	for (int i = 1; i <= n; i++) {
  		int x, y;
  		scanf("%d%d",&x,&y);
  		--x,--y;
  		if (maxx[x] >= 0) need -= maxx[x] - minx[x] + 1;
  		if (maxy[y] >= 0) need -= maxy[y] - miny[y] + 1;

  		minx[x] = min(minx[x], y);
  		maxx[x] = max(maxx[x], y);
  		miny[y] = min(miny[y], x);
  		maxy[y] = max(maxy[y], x);

  		need += maxx[x] - minx[x] + 1;
  		need += maxy[y] - miny[y] + 1;
  		if (!reqs && i == n) {
  			int t;
  			scanf("%d",&t);
  			n += t;
  			reqs = true;
  		}
  		if (reqs) puts(need == 2*i ? "YES" : "NO");
    }


      
    return 0;
}